import { system, world } from "@minecraft/server";

const recipes = [
    {
        output: "cauliflower_wings",
        ingredients: [
            { item: "ww_dx:cauliflower", count: 1 },
            { item: "ww_dx:garlic", count: 1 },
            { item: "ww_dx:salt", count: 1 },
            { item: "ww_dx:chili_powder", count: 1 },
        ],
    },
    {
        output: "chicken_nuggets",
        ingredients: [
            { item: "minecraft:chicken", count: 1 },
        ],
    },
    {
        output: "onion_rings",
        ingredients: [
            { item: "ww_dx:onion", count: 1 },
            { item: "ww_dx:flour", count: 1 },
            { item: "ww_dx:olive_oil", count: 1 },
        ],
    },
    {
        output: "potato_chips",
        ingredients: [
            { item: "minecraft:potato", count: 1 },
            { item: "ww_dx:olive_oil", count: 1 },
            { item: "ww_dx:salt", count: 1 },
        ],
    },
    {
        output: "pretzel",
        ingredients: [
            { item: "ww_dx:dough", count: 1 },
            { item: "ww_dx:salt", count: 1 },
        ],
    },
];




const air_fryer = new Map();


function processAirFryerInventory(entity) {
    const id = entity.id;


    if (air_fryer.get(id)?.isProcessing) {
        return;
    }

    const inventoryComponent = entity.getComponent("minecraft:inventory");

    if (!inventoryComponent || !inventoryComponent.container) {

        return;
    }

    const inventory = inventoryComponent.container;

    for (const recipe of recipes) {

        let matches = true;

        const ingredientsMap = new Map(
            recipe.ingredients.map((ingredient) => [ingredient.item, ingredient.count])
        );

        for (let i = 0; i < inventory.size; i++) {
            const item = inventory.getItem(i);
            if (item) {
                if (ingredientsMap.has(item.typeId)) {
                    const remainingCount = ingredientsMap.get(item.typeId) - item.amount;
                    if (remainingCount <= 0) {
                        ingredientsMap.delete(item.typeId);
                    } else {
                        ingredientsMap.set(item.typeId, remainingCount);
                    }
                } else {

                    matches = false;
                    break;
                }
            }
        }

        if (matches && ingredientsMap.size === 0) {
            entity.runCommandAsync("summon ww_dx:processing_particle ~ ~1 ~")

            for (const ingredient of recipe.ingredients) {
                let remainingToRemove = ingredient.count;

                for (let i = 0; i < inventory.size; i++) {
                    const item = inventory.getItem(i);
                    if (item && item.typeId === ingredient.item) {
                        if (item.amount > remainingToRemove) {
                            item.amount -= remainingToRemove;
                            inventory.setItem(i, item);
                            break;
                        } else {
                            remainingToRemove -= item.amount;
                            inventory.setItem(i, undefined);
                        }
                    }
                }
            }


            air_fryer.set(id, { isProcessing: true });
            system.runTimeout(() => {
                if (!entity.isValid()) return;
                const { x, y, z } = entity.location;
                entity.runCommandAsync(`loot spawn ${x} ${y + 1} ${z} loot ${recipe.output}`);
                entity.runCommandAsync("event entity @e[type=ww_dx:processing_particle,r=1] ww_dx:despawn")
                entity.runCommandAsync("playsound ww_dx:finish_cooking @a[r=5]")


                air_fryer.set(id, { isProcessing: false });
            }, 200);

            return;
        } else {

        }
    }


}
let worldInitialize = false;
world.afterEvents.playerSpawn.subscribe((event) => {
    worldInitialize = true;

})
function checkAirFryer() {
    if(worldInitialize){
    const currentDimension = world.getDimension(world.getPlayers()[0].dimension.id);

    for (const entity of currentDimension.getEntities()) {
        if (entity.typeId === "ww_dx:air_fryer") {
            if (!air_fryer.has(entity.id)) {
                air_fryer.set(entity.id, { isProcessing: false });
            }

            processAirFryerInventory(entity);
        }
    }
}
}

system.runInterval(() => {
    checkAirFryer();
}, 20); 
